<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;

class ParamKDSService {


	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

	public function GetProdInterval($CDARVPROD, $CDARVPRODFINAL, $CDSETOR, $isNew){
		$params = array(
			':CDARVPRODINI' 	=> $CDARVPROD,
			':CDARVPRODFINAL'	=> $CDARVPRODFINAL,
			':CDSETOR'			=> $CDSETOR
		);

		$return = [];

		if ($isNew)
			$return = $this->entityManager->getConnection()->fetchAll(self::GET_PRODUCT_KDS, $params);
		else if (!$isNew)
			$return = $this->entityManager->getConnection()->fetchAll(self::GET_PRODUCT_KDS_EDIT, $params);
		return $return;
	}

	/**
	 * 	Parâmetros necessários para essa função:
	 *  :CDFILIAL
	 *  :CDLOJA
	 *  :CDSETOR
	 *  :IDTIPOSETOR
	 */

	public function verificarProdutosSetor ($params) {

			$podeSalvar = true;

			$setoresLoja = $this->entityManager->getConnection()->fetchAll(self::GET_SETORES_LOJA, $params);

			if(sizeof($setoresLoja) > 0) {

				$produtosNovoSetor = $this->entityManager->getConnection()->fetchAll(self::GET_PRODUTOS_SETOR, $params);
				$produtosSetorLoja = [];
				$aux = [];

				foreach ($setoresLoja as $setor) {

						$parametrosSetor = array(
							':CDSETOR'	    => $setor['CDSETOR']
						);

				    $produtosSetor = $this->entityManager->getConnection()->fetchAll(self::GET_PRODUTOS_SETOR, $parametrosSetor);
				    array_push($produtosSetorLoja, $produtosSetor);

				    if(sizeof($produtosSetorLoja) > 0 && sizeof($produtosSetorLoja) > 0) {
				    	$vetorCdProduto = array();
			    		for( $i = 0; $i < sizeof($produtosSetorLoja[0]); $i++){
							$vetorCdProduto[] = $produtosSetorLoja[0][$i]['CDPRODUTO'] ;
						}
						for( $i = 0; $i < sizeof($produtosNovoSetor); $i++){
							for($cont = 0; $cont < sizeof($vetorCdProduto); $cont++){
								if ($vetorCdProduto[$cont] == $produtosNovoSetor[$i]['CDPRODUTO']) {
									$podeSalvar = false;
									if(sizeof($aux) == 0)  {
										$aux[] = "O setor não pôde ser cadastrado pois não é permitido ter o mesmo produto em setores do mesmo tipo.";
										$aux[] = "Setores que possuem o mesmo produto deste setor: ";
										$aux[] = " ";
									}

									$string = "Setor: " . $setor['CDSETOR'] . " - " . $produtosNovoSetor[$i]['CDPRODUTO']." - ".$produtosNovoSetor[$i]['NMPRODUTO'];

									$igual = false;
									foreach ($aux as $linha) {
										if($linha == $string)
											$igual = true;
									}

									if(!$igual)
										$aux[] = $string;

								}
							}
						}
				    }
				}


				if(!$podeSalvar)
					$podeSalvar = $aux;
			}

			return $podeSalvar;
	}

	public function getSetoresProducao ($params) {
		$return = $this->entityManager->getConnection()->fetchAll(self::GET_SETORES_PRODUCAO, $params);
		return $return;
	}

	public function getObservacaoProduto ($params) {
		$return = $this->entityManager->getConnection()->fetchAll(self::GET_OBS_PRODUTOS, $params);
		return $return;
	}

	public function getIntervalosProduto ($params) {
		$return = $this->entityManager->getConnection()->fetchAll(self::GET_INTERVALO_PRODUTOS, $params);
		return $return;
	}

	public function getProdutosSetor ($params) {
		$return = $this->entityManager->getConnection()->fetchAll(self::GET_PRODUTOS_SETOR_IMPORTACAO, $params);
		return $return;
	}

	public function insertProdutoSetor ($params) {
		$return = $this->entityManager->getConnection()->executeQuery(self::INSERT_PRODUTOS_SETOR, $params);
		return $return;
	}

	public function insertObsProduto ($item) {
		$params = array(
	    	':CDPRODUTO'        => $item['CDPRODUTO'],
        	':CDSETOR'          => $item['CDSETOR'],
	    	':CDGRPOCOR'  		=> $item['CDGRPOCOR'],
	    	':CDOCORR'			=> $item['CDOCORR'],
	    	':NRTEMPOPROD'  	=> $item['NRTEMPOPROD']
    );
		$return = $this->entityManager->getConnection()->executeQuery(self::ADICIONA_OBSERVACAO_PRODUTO_SETOR, $params);
		return $return;
	}

	public function insertIntervaloProduto ($intevalo) {
		$params = array(
        ':CDSETOR'          => $intevalo['CDSETOR'],
	    ':CDPRODUTO'        => $intevalo['CDPRODUTO'],
	    ':NRSEQINTERVALO'  	=> $intevalo['NRSEQINTERVALO'],
	    ':NRTEMPOINTER'		=> $intevalo['NRTEMPOINTER']
    );
		$return = $this->entityManager->getConnection()->executeQuery(self::CRIA_PRODUTO_INTER, $params);
		return $return;
	}

	public function deletarTodasObservacoesIntervalosProduto($conn, $row) {
		 try {
	        $params = array(
		        ':CDSETOR'   => $row['CDSETOR'],
			    ':CDPRODUTO' => $row['CDPRODUTO']
		    );
            $conn->executeQuery(self::DELETE_INTERVALOS_SETOR, $params);
            $conn->executeQuery(self::DELETE_OBSERVACAO_SETOR, $params);

	    } catch (\Exception $e) {
            // $this->entityManager->getConnection()->rollBack();
            throw $e;
        }
	}

	public function importarSetor ($row){
		$total = 0;
		if(isset($row['CDSETOR']) && count($row['CDSETOR'])){
			foreach($row['CDSETOR'] as $setor){
				$params = array(
					':CDFILIAL' 	 => $row['CDFILIAL'],
					':CDFILIAL_DEST' => $row['CDFILIAL_DEST'],
					':CDSETOR'		 => $setor
				);
				$total = $total + $this->criaSetorFilial($params)->rowCount();
			}
		}

		return $total;
	}

	private function criaSetorFilial($params){
		return $this->entityManager->getConnection()->executeQuery(self::CRIA_SETOR_FILIAL, $params);
	}

	public function totalSetoresPorLoja ($row){
		$params = array(
			':CDFILIAL' => $row['CDFILIAL'],
			':CDSETOR'  => $row['CDSETOR']
		);

		return (int)$this->entityManager->getConnection()->executeQuery(self::TOTAL_SETORES_LOJA,$params)->fetch()['TOTAL_SETORES'];
	}
	
	public function totalLinhaSetor ($row){
		$params = array(
			':CDFILIAL' => $row['CDFILIAL'],
			':CDSETOR'  => $row['CDSETOR']
		);

		return (int)$this->entityManager->getConnection()->executeQuery(self::TOTAL_LINHA_SETOR,$params)->fetch()['TOTAL_LINHA'];
	}

	public function atualizarHabilitacao($row) {
		$params = array(
			':CDSETOR' => $row['CDSETOR']
		);

		return $this->entityManager->getConnection()->executeQuery(self::ATUALIZA_HABILITACAO, $params);
	}

	public function updateUnidadeKDS($row) {
		$params = array(
			':CDFILIAL' => $row['CDFILIAL'],
			':NRATRAPADRAO' => $row['NRATRAPADRAO'],
			':IDEXIBESTATIS' => $row['IDEXIBESTATIS']
		);
		return $this->entityManager->getConnection()->executeQuery(self::ATUALIZA_UNIDADEKDS, $params);
	}

	public function setLinhaPrincipal($CDLINHAPROD, $CDFILIAL){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDLINHAPROD' => $CDLINHAPROD
		);
		return $this->entityManager->getConnection()->executeQuery(self::ATUALIZA_LINHAPROD, $params);
	}

	public function setCorrespondente($CDLINHAPROD, $CDFILIAL, $CDSETOR){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDSETOR' => $CDSETOR,
			':CDLINHAPROD' => $CDLINHAPROD
		);
		return $this->entityManager->getConnection()->executeQuery(self::ATUALIZA_CORRESPONDENTE, $params);
	}

	public function deleteLinhasetor($CDLINHAPROD, $CDFILIAL){
			$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDLINHAPROD' => $CDLINHAPROD
		);
		return $this->entityManager->getConnection()->executeQuery(self::DELETE_LINHAPRODSETOR, $params);
	}


	public function somaLinhaPrincipal($CDLINHAPROD, $CDFILIAL){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDLINHAPROD' => $CDLINHAPROD
		);
		return $this->entityManager->getConnection()->fetchAll(self::ATUALIZA_SOMALINHAPROD, $params)[0]['SOMA'];
	}

	public function deleteLinhasetorprincipal($CDFILIAL){
		$params = array(
			':CDFILIAL' => $CDFILIAL
		);
		return $this->entityManager->getConnection()->executeQuery(self::DELETE_SETOR, $params);
	}

	public function setLinhasetorprincipal($CDLINHAPROD, $CDFILIAL){
			$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDLINHAPROD' => $CDLINHAPROD
		);
		return $this->entityManager->getConnection()->executeQuery(self::ATUALIZA_LINHAPRODSETORCORRESP, $params);
	}

	public function getSetorprincipal($CDFILIAL){
		$params = array(
			':CDFILIAL' => $CDFILIAL
		);
		return $this->entityManager->getConnection()->fetchAll(self::GET_SETOR, $params);
	}

	public function deleteSetorprincipal($CDSETOR, $CDFILIAL){
			$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDSETOR' => $CDSETOR
		);
		return $this->entityManager->getConnection()->executeQuery(self::DELETE_SETORLINHAPRINCIPAL, $params);
	}

	const ATUALIZA_LINHAPROD = "
		UPDATE LINHAPROD LP
		SET LP.IDLINHAPRINCIPAL = 'N'
		WHERE LP.CDLINHAPROD != :CDLINHAPROD AND LP.CDFILIAL = :CDFILIAL
	";

	const GET_SETOR = "
		SELECT * FROM LINHAPRODSETOR LP
		WHERE LP.CDLINHAPROD = (SELECT CDLINHAPROD FROM LINHAPROD WHERE IDLINHAPRINCIPAL = 'S' AND CDFILIAL = :CDFILIAL) AND CDFILIAL = :CDFILIAL
	";

	const DELETE_SETOR = "
		DELETE FROM LINHAPRODSETOR LP
		WHERE LP.CDLINHAPROD = (SELECT CDLINHAPROD FROM LINHAPROD WHERE IDLINHAPRINCIPAL = 'S' AND CDFILIAL = :CDFILIAL) AND CDFILIAL = :CDFILIAL
	";

	const DELETE_LINHAPRODSETOR = "
		DELETE FROM LINHAPRODSETOR
		WHERE CDLINHAPROD = :CDLINHAPROD AND CDFILIAL = :CDFILIAL
	";

	const DELETE_SETORLINHAPRINCIPAL = "
		DELETE FROM LINHAPRODSETOR
		WHERE CDSETORCORRESP = :CDSETOR  AND CDFILIAL = :CDFILIAL
	";

	const ATUALIZA_LINHAPRODSETORCORRESP = "
		UPDATE LINHAPRODSETOR
		SET CDSETORCORRESP = NULL
		WHERE CDLINHAPROD = :CDLINHAPROD AND CDFILIAL = :CDFILIAL
	";

	const ATUALIZA_CORRESPONDENTE = "
		UPDATE LINHAPRODSETOR LS
		SET LS.CDSETORCORRESP = :CDSETOR
		WHERE LS.CDLINHAPROD != :CDLINHAPROD AND LS.CDFILIAL = :CDFILIAL
	";

	const ATUALIZA_SOMALINHAPROD = "
		SELECT SUM(LP.NRPERCDEMANDA) AS SOMA
		FROM LINHAPROD LP
		WHERE LP.CDLINHAPROD != :CDLINHAPROD AND LP.CDFILIAL = :CDFILIAL
	";

	const ATUALIZA_HABILITACAO = "
		UPDATE SETORFILIAL SF
		SET SF.IDHABAGRUPPROD = 'N'
		WHERE SF.CDSETOR = :CDSETOR
	";

	const ATUALIZA_UNIDADEKDS = "UPDATE PARAVEND SET NRATRAPADRAO = :NRATRAPADRAO, IDEXIBESTATIS = :IDEXIBESTATIS WHERE CDFILIAL = :CDFILIAL";

	const TOTAL_SETORES_LOJA = "
		SELECT COUNT(*) TOTAL_SETORES
		FROM SETORLOJA SL
		JOIN SETOR S
		ON SL.CDSETOR     = S.CDSETOR
		WHERE SL.CDFILIAL = :CDFILIAL
		AND SL.CDSETOR     = :CDSETOR
		ORDER BY SL.CDSETOR
	";
	
	const TOTAL_LINHA_SETOR = "
		SELECT COUNT(CDSETOR) TOTAL_LINHA
		FROM LINHAPRODSETOR LS
		WHERE CDFILIAL = :CDFILIAL
		  AND CDSETOR = :CDSETOR
	";

	const CRIA_SETOR_FILIAL = "
		INSERT
		INTO SETORFILIAL
		  (
		    CDSETOR,
		    CDFILIAL,
		    IDHABSOMKDS,
		    IDHABROLLBKDS,
		    IDHABTIMERPROD,
		    IDHABSOMPROD,
		    IDHABCONTSOMPROD,
		    IDBLOQPRODKDS,
		    NRROLLBTIME,
		    IDCONTSOMKDS,
		    IDHABPREENVIO,
		    IDMOSTRAORIGEM,
		    IDUTLINTPAINEL,
		    NRATRASOSOMPROD,
		    NRPRODATRAINISOM,
		    CDARQUIVO,
		    IDCONCDIRETO,
		    IDHABCANCDLV,
		    IDHABCANCBAL,
		    IDHABCANCMES,
		    IDHABCANCCMD,
		    IDHABCANCTHR,
		    IDHABCANCTGO,
		    IDHABSCANCODE,
		    IDAUMENTARESUMO,
		    IDIMPRPICKLIST,
		    IDHABAGRUPPROD,
		    NRCORVGM,
		    IDHABPEDLIB,
		    IDHABBTNACTION,
		    IDHABEXPFLUID,
		    IDLIBCONDPG,
		    IDEXIBCONDLIB,
		    IDCONCAUT,
		    IDPRIORM,
		    IDHABLIBDIRETOEXP,
		    IDHABESTGERAL,
		    NRMULTIPULO,
		    IDFRNONNTF,
		    DSURLCHECKSERVICE,
		    NRCONCAUTCHECK
		  )
		SELECT SF.CDSETOR,
		  :CDFILIAL_DEST,
		  SF.IDHABSOMKDS,
		  SF.IDHABROLLBKDS,
		  SF.IDHABTIMERPROD,
		  SF.IDHABSOMPROD,
		  SF.IDHABCONTSOMPROD,
		  SF.IDBLOQPRODKDS,
		  SF.NRROLLBTIME,
		  SF.IDCONTSOMKDS,
		  SF.IDHABPREENVIO,
		  SF.IDMOSTRAORIGEM,
		  SF.IDUTLINTPAINEL,
		  SF.NRATRASOSOMPROD,
		  SF.NRPRODATRAINISOM,
		  SF.CDARQUIVO,
		  SF.IDCONCDIRETO,
		  SF.IDHABCANCDLV,
		  SF.IDHABCANCBAL,
		  SF.IDHABCANCMES,
		  SF.IDHABCANCCMD,
		  SF.IDHABCANCTHR,
		  SF.IDHABCANCTGO,
		  SF.IDHABSCANCODE,
		  SF.IDAUMENTARESUMO,
		  SF.IDIMPRPICKLIST,
		  SF.IDHABAGRUPPROD,
		  SF.NRCORVGM,
		  SF.IDHABPEDLIB,
		  SF.IDHABBTNACTION,
		  SF.IDHABEXPFLUID,
		  SF.IDLIBCONDPG,
		  SF.IDEXIBCONDLIB,
		  SF.IDCONCAUT,
		  SF.IDPRIORM,
		  SF.IDHABLIBDIRETOEXP,
		  SF.IDHABESTGERAL,
		  SF.NRMULTIPULO,
		  SF.IDFRNONNTF,
		  SF.DSURLCHECKSERVICE,
		  SF.NRCONCAUTCHECK
		FROM SETORFILIAL SF
		JOIN SETOR SE
		ON SF.CDSETOR = SE.CDSETOR
		LEFT JOIN ARQUIVOS AR
		ON AR.CDARQUIVO   = SF.CDARQUIVO
		WHERE SF.CDFILIAL = :CDFILIAL
		AND SF.CDSETOR    = :CDSETOR
		AND NOT EXISTS
		  (SELECT CDSETOR
		  FROM SETORFILIAL
		  WHERE CDFILIAL = :CDFILIAL_DEST
		  AND CDSETOR    = :CDSETOR
		  )
	";

	const DELETE_INTERVALOS_SETOR = "
		DELETE FROM SETORPRODOBS
		WHERE CDPRODUTO = :CDPRODUTO
		  AND CDSETOR   = :CDSETOR
	";

	const DELETE_OBSERVACAO_SETOR = "
		DELETE FROM SETORPRODINTER
		WHERE CDPRODUTO = :CDPRODUTO
		  AND CDSETOR   = :CDSETOR
	";

	const CRIA_PRODUTO_INTER = "
		INSERT INTO SETORPRODINTER
		(CDPRODUTO, CDSETOR, NRSEQINTERVALO, NRTEMPOINTER)
		VALUES
		(:CDPRODUTO, :CDSETOR, :NRSEQINTERVALO, :NRTEMPOINTER)
	";

	const GET_INTERVALO_PRODUTOS = "
		SELECT CDPRODUTO, CDSETOR, NRSEQINTERVALO, NRTEMPOINTER
		FROM SETORPRODINTER
		WHERE CDPRODUTO = :CDPRODUTO
		AND   CDSETOR   = :CDSETOR
	";

	const ADICIONA_OBSERVACAO_PRODUTO_SETOR = "
		INSERT INTO SETORPRODOBS
			(CDPRODUTO, CDSETOR, CDGRPOCOR, CDOCORR, NRTEMPOPROD)
		VALUES
			(:CDPRODUTO, :CDSETOR, :CDGRPOCOR, :CDOCORR, :NRTEMPOPROD)
	";

	const GET_OBS_PRODUTOS = "
		SELECT CDPRODUTO, CDSETOR, CDGRPOCOR, CDOCORR, NRTEMPOPROD
		FROM SETORPRODOBS
		WHERE CDPRODUTO = :CDPRODUTO
		AND   CDSETOR   = :CDSETOR
	";

	const INSERT_PRODUTOS_SETOR = "
		INSERT INTO SETORPRODUTO ( CDSETOR, CDPRODUTO, NRTEMPOPROD, NRTEMPOEXIB,
															 IDRESUMOPRODKDS, IDRESTRICAOORIGEM, DSAPELIDORESUMO, IDIMPRPRODPICK )
		VALUES ( :CDSETOR,
						 :CDPRODUTO,
						 :NRTEMPOPROD,
						 :NRTEMPOEXIB,
						 :IDRESUMOPRODKDS,
						 :IDRESTRICAOORIGEM,
						 :DSAPELIDORESUMO,
						 :IDIMPRPRODPICK)
	";

	const GET_PRODUTOS_SETOR_IMPORTACAO = "
			SELECT SP.CDPRODUTO,
			       SP.NRTEMPOPROD,
			       SP.NRTEMPOEXIB,
			       SP.IDRESUMOPRODKDS,
			       SP.IDRESTRICAOORIGEM,
			       SP.DSAPELIDORESUMO,
			       SP.IDIMPRPRODPICK
			FROM SETORPRODUTO SP
			JOIN SETOR S ON SP.CDSETOR = S.CDSETOR
			JOIN PRODUTO P ON SP.CDPRODUTO = P.CDPRODUTO
			WHERE SP.CDSETOR = :CDSETOR
			ORDER BY SP.CDPRODUTO
	";

	const GET_SETORES_PRODUCAO = "
		SELECT SP.CDSETOR
		FROM SETORPRODUTO SP
		JOIN SETOR S
    ON SP.CDSETOR = S.CDSETOR
		WHERE S.IDTIPOSETOR = 'P'
		AND SP.CDPRODUTO = :CDPRODUTO
		ORDER BY CDSETOR
	";

	const GET_PRODUCT_KDS = "
   SELECT DISTINCT P.CDPRODUTO, P.CDARVPROD
       FROM PRODUTO P
      WHERE P.CDARVPROD BETWEEN :CDARVPRODINI AND :CDARVPRODFINAL
        AND P.IDPRODATIVPR = 'S'
        AND P.CDPRODUTO NOT IN
        (SELECT CDPRODUTO
        FROM SETORPRODUTO
        WHERE CDSETOR  = :CDSETOR
        )
        AND P.CDNVPRODUTO = (SELECT MAX(CDNVPRODUTO) AS CDNVPRODUTO FROM PRODUTO)
    ";

		const GET_PRODUCT_KDS_EDIT = "
		SELECT CDPRODUTO
        FROM SETORPRODUTO
        WHERE CDSETOR  = :CDSETOR
        AND CDPRODUTO = :CDARVPRODINI
    ";

    const GET_PRODUTOS_SETOR = "
    	SELECT P.CDPRODUTO,
			P.NMPRODUTO
			FROM SETORPRODUTO SP
			JOIN SETOR S
			ON SP.CDSETOR = S.CDSETOR
			JOIN PRODUTO P
			ON SP.CDPRODUTO = P.CDPRODUTO
			WHERE SP.CDSETOR  = :CDSETOR
			ORDER BY P.CDARVPROD
    ";

    const GET_SETORES_LOJA = "
    	SELECT SL.CDLOJA,
			  SL.CDSETOR,
			  S.IDTIPOSETOR
			FROM SETORLOJA SL
			JOIN SETOR S
			ON SL.CDSETOR     = S.CDSETOR
			WHERE SL.CDFILIAL = :CDFILIAL
			AND SL.CDLOJA     = :CDLOJA
      AND IDTIPOSETOR   = :IDTIPOSETOR
			ORDER BY SL.CDSETOR
    ";

}